LeetCode#11. Container With Most Water

11. Container With Most Water

Given n non-negative integers a1, a2, …, an, where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of the line i is at (i, ai) and (i, 0). Find two lines, which, together with the x-axis forms a container, such that the container contains the most water.

Notice that you may not slant the container.

Example 1:

p11

Input: height = [1,8,6,2,5,4,8,3,7]
Output: 49
Explanation: The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.

Example 2:

Input: height = [1,1]
Output: 1

Example 3:

Input: height = [4,3,2,1,4]
Output: 16

Example 4:

Input: height = [1,2,1]
Output: 2

Constraints:

  • n == height.length
  • 2 <= n <= 105
  • 0 <= height[i] <= 104

暴力
这题一开始想当然的是暴力遍历去取最大值

class Solution {
    public int maxArea(int[] height) {
    int max=0;
         for (int i = 0; i < height.length; i++) {
             for (int j = i+1; j < height.length-1; j++) {
                 int h=height[i]<height[j]?height[i]:height[j];
                 int w=j-i;
                 int area=h*w;
                 max=max>area?max:area;
             }
         }
         return max;
    }
}

但是数据量一大就会有问题

官方-双指针

class Solution {
    public int maxArea(int[] height) {
        int max=0;int i=0;int j=height.length-1;
        while (i!=j){
            int area=Math.min(height[i],height[j])*(j-i);
            max=Math.max(max,area);
            if (height[i]>height[j]){
                --j;
            }else{
                ++i;
            }
        }
        return max;
    }
}

// TODO 双指针为什么是正确的呢?

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值